﻿using System.Web.Http;
using Sitecore.Services.Core;
using Sitecore.Services.Infrastructure.Sitecore.Services;
using Platform.Feature.ServicesClient.Models;
using Platform.Feature.ServicesClient.Repositories;

namespace Platform.Feature.ServicesClient.Controllers
{
    // this will be called with a routing by default:  {Controller-Namespace}/{Controller}/{ID}/{CustomActionName}
    // http://careers.dev.local/sitecore/api/ssc/WesleyanPlatform-Feature-ServicesClient/Entity/1/DoSomethingCustom

    [ServicesController]
    public class EntityController : EntityService<Entity>
    {
        private readonly ICustomRepositoryActions<Entity> _customRepositoryActions;

        public EntityController(ICustomRepositoryActions<Entity> repository) : base(repository)
        {
            _customRepositoryActions = repository;
        }

        public EntityController() : this(new EntityRespository())
        {
        }


        [HttpGet]
        [ActionName("DoSomethingCustom")]
        public string Get()
        {
            return _customRepositoryActions.DoSometingCustom();
        }
    }
}